Subject: Re: [PATCH 3/3] odb: properly close sources before freeing them

From: Patrick Steinhardt <[email-masked]>
Date: Sat, 6 Dec 2025 12:38:31 +0100

On Fri, Dec 05, 2025 at 06:14:22PM -0500, Eric Sunshine wrote:
> On Fri, Dec 5, 2025 at 6:36 AM Patrick Steinhardt <[email-masked]> wrote:
> > In the next commit we are about to move the packfile store into the ODB
> > source so that we have one store per source. This will lead to a memory
> > leak in the following commit when reading data from a submodule via
> > git-grep(1):
> > [...]
> > Signed-off-by: Patrick Steinhardt <[email-masked]>
> 
> Considering that this is patch [3/3], to what does "In the next
> commit..." refer?

Good catch! I split this out of another, bigger, patch series. But as
I've started to hit the leak in a different patch series, as well, I
decided to split it out into a smaller patch series.

I've queued the following change locally, but will refrain from sending
out a new version for now.

Thanks!

Patrick

1:  5c15065406 = 1:  9f813d92f3 builtin/repack: fix geometric repacks with promisor remotes
2:  2fa3991003 = 2:  02167bfb16 builtin/gc: fix condition for whether to write commit graphs
3:  a06d0716c3 ! 3:  c9ca233c29 odb: properly close sources before freeing them
    @@ Commit message
         odb: properly close sources before freeing them
     
         In the next commit we are about to move the packfile store into the ODB
    -    source so that we have one store per source. This will lead to a memory
    -    leak in the following commit when reading data from a submodule via
    -    git-grep(1):
    +    source so that we have one store per source. This can lead to a memory
    +    leak when reading data from a submodule via git-grep(1):
     
           Direct leak of 192 byte(s) in 1 object(s) allocated from:
             #0 0x55555562e726 in calloc (git+0xda726)